﻿using System;
using System.Data;
using System.Text;

namespace SQL_Tool
{
    class DatabaseWrapperInvalidQueryException : Exception
    {
        public override string Message { get; } = "No message :p";

        public DatabaseWrapperInvalidQueryException() { }
        public DatabaseWrapperInvalidQueryException(string message)
        {
            Message = message;
        }
    }
    abstract class DatabaseWrapper
    {
        public abstract ConnectionState State { get; }

        protected DatabaseWrapper() { }
        protected DatabaseWrapper(string connectionString) { }
        protected DatabaseWrapper(string host, string database, string username, string password) { }

        public abstract int ExecuteCommand(string sqlStatement);
        public abstract DataTable ExecuteQuery(string sqlStatement, DataTable dt = null);
        public abstract long GetExecutionTime();

        public string DataTableToString(DataTable dt)
        {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < dt.Columns.Count;i++)
            {
                sb.Append(dt.Columns[i] + "\t");
            }
            sb.Remove(sb.Length - 1, 1);
            sb.AppendLine();
            foreach (DataRow row in dt.Rows)
            {
                for (int i = 0; i < dt.Columns.Count; i++)
                {
                    sb.Append(row[i] + "\t");
                }
                sb.Remove(sb.Length - 1, 1);
                sb.AppendLine();
            }
            return sb.ToString();
        }
    }
}
