﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace SQL_Tool
{
    public partial class Form1 : Form
    {
        private DataTable _dt = new DataTable();
        private DatabaseWrapper _dbWrapper = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (Uri.CheckHostName(txtServer.Text) == UriHostNameType.Unknown)
            {
                MessageBox.Show("Server not valid!");
                return;
            }
            try
            {
                _dbWrapper = new MySqlWrapper(txtServer.Text, txtDatabase.Text, txtUser.Text, txtPassword.Text);
            }
            catch (Exception)
            {
                MessageBox.Show("Failed to open connection!");
                return;
            }
            
        }

        private void btnQuery_Click(object sender, EventArgs e)
        {

            if (_dbWrapper == null || _dbWrapper.State != ConnectionState.Open)
            {
                MessageBox.Show("Please provide some connection details :-)");
                return;
            }
            try
            {
                _dt = _dbWrapper.ExecuteQuery(txtQuery.Text);
                txtOutput.Text = _dbWrapper.DataTableToString(_dt);
                dataGridOutput.DataSource = _dt;
                label8.Text = $"Ausführungszeit: {_dbWrapper.GetExecutionTime()} ms";
            }
            catch (DatabaseWrapperInvalidQueryException ex)
            {
                txtOutput.Text = "Exception!\r\nMessage:\r\n" + ex.Message;
            }
        }

        private void txtQuery_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Enter))
            {
                this.btnQuery_Click(sender, e);
            }
        }
    }
}
